summaryrefslogtreecommitdiffstats
path: root/system/mediaextract/mediaextract.SlackBuild
diff options
context:
space:
mode:
Diffstat (limited to 'system/mediaextract/mediaextract.SlackBuild')
-rw-r--r--system/mediaextract/mediaextract.SlackBuild99
1 files changed, 99 insertions, 0 deletions
diff --git a/system/mediaextract/mediaextract.SlackBuild b/system/mediaextract/mediaextract.SlackBuild
new file mode 100644
index 0000000000..d64d96b8a9
--- /dev/null
+++ b/system/mediaextract/mediaextract.SlackBuild
@@ -0,0 +1,99 @@
+#!/bin/bash
+
+# Slackware build script for mediaextract
+
+# Written by B. Watson (urchlay@slackware.uk)
+
+# Licensed under the WTFPL. See http://www.wtfpl.net/txt/copying/ for details.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=mediaextract
+VERSION=${VERSION:-1.1.1}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-v$VERSION
+unzip $CWD/$PRGNAM-v$VERSION.zip -x '*/build-*/*'
+cd $PRGNAM-v$VERSION
+chown -R root:root .
+find -L . -perm /111 -a \! -perm 755 -a -exec chmod 755 {} \+ -o \
+ \! -perm /111 -a \! -perm 644 -a -exec chmod 644 {} \+
+
+# 20220319 bkw: gcc and clang were both hitting the 4GB per-process
+# memory limit, due to ridiculous preprocessor abuse in riff.c. The
+# thing was doing a bunch of nested macro expansions, to determine
+# the maximum size for an array... turns out the size it calculated
+# was 9. The patch just hardcodes it to 9 and gets rid of the nested
+# macro calls. This should be revisited when/if there's a new
+# version of mediaextract.
+patch -p1 < $CWD/compilefix.diff
+
+cd source
+mkdir -p build-linux32 build-linux64
+
+# The last -e here stops it building the man page. Do this because
+# we have our own (better-formatted) man page, and also to fix
+# parallel builds.
+sed -i \
+ -e "s,-Werror,," \
+ -e "/^CFLAGS/s,-O2 -g,$SLKCFLAGS," \
+ -e "/all:/s, [^ ]*MANPAGE.*$,," \
+ Makefile
+
+make
+
+# upstream's install target is weird and inflexible.
+mkdir -p $PKG/usr/bin $PKG/usr/man/man1 $PKG/usr/doc/$PRGNAM-$VERSION
+install -s -m0755 build-linux*/$PRGNAM $PKG/usr/bin
+install -m0644 LICENSE.txt ../README* $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+# upstream's generated man page has horrible formatting, and the
+# author's own name gets mangled (the รถ came out as ??). I spent
+# some time reformatting it in RST, and also added the examples from
+# the README.md.
+gzip -9c < $CWD/$PRGNAM.1 > $PKG/usr/man/man1/$PRGNAM.1.gz
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE